﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using System.Collections;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls.ChartView;
using System.Reflection;

namespace BaseApplicationProject
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {   
            InitializeComponent();

            Random r = new Random();

            Brush[] brushesCollection = new Brush[]
            {
                Brushes.MediumSeaGreen,
                Brushes.Orange,
                Brushes.OrangeRed
            };

            for (int i = 0; i < 3; i++)
            {
                ScatterPointSeries sps = new ScatterPointSeries();

                Brush brush = brushesCollection[i]; // This will be dynamic

                var style = new Style(typeof(Path));
                style.Setters.Add(new Setter(Path.FillProperty, brush));
                sps.DefaultVisualStyle = style;

                sps.ItemsSource = DataItem.GenerateItems(r.Next(3, 10));

                sps.XValueBinding = new PropertyNameDataPointBinding() { PropertyName = "XPath" };
                sps.YValueBinding = new GenericDataPointBinding<DataItem, double>() { ValueSelector = item => item.Function };

                Chart.Series.Add(sps);
            }
        }
    }
    
    public class DataItem
    {
        public double XPath { get; set; }
        public double Function { get; set; }

        static Random r = new Random();

        public static IEnumerable GenerateItems(int count)
        {
            ObservableCollection<DataItem> result = new ObservableCollection<DataItem>();
           
            for (int i = 0; i < count; i++)
            {
                result.Add(new DataItem 
                { 
                    XPath = r.Next(0, 30) + i, 
                    Function = r.Next(0, 30) + i 
                });
            }

            return result;
        }
    }
}
